Include "Lib_Engine.bb"
rInit 800, 600, 32, 2

;Globs
Global FPS#

;Camera
Global Cam.Entity = rCreateCamera()
rCameraClsColor Cam, 64, 127, 255

;Entity
Global Entity.Entity[7]
Entity[1] = rCreateCube()
Entity[2] = rCreateCylinder()
Entity[3] = rCreateFrustrum()
Entity[4] = rCreateTube()
Entity[5] = rCreateCone()
Entity[6] = rCreateSphere()
Entity[7] = rCreateTorus()
cnt = 0
For x = 1 To 4
  For y = 1 To 2
    cnt = cnt + 1
    If cnt < 8 Then
      rPositionEntity Entity[cnt], x * 2 - 6 + y, y * 2 - 3.5, 4.5
      rEntityColor Entity[cnt], Rand(0, 255), Rand(0, 255), Rand(0, 255)
    EndIf
  Next
Next

gamma = False
proj = False
wf = False
fps# = 100
While Not KeyHit(1)
  For i = 1 To 7
    rTurnEntity Entity[i], 80.0 / fps#, 80.0 / fps#
  Next
  If KeyHit(2) Then
    For i = 1 To 7
      rEntityVertexColorRandom Entity[i]
      rEntityColor Entity[i], 255, 255, 255
    Next
  EndIf
  If KeyHit(3) Then gamma = 1 - gamma
  If gamma Then
    gam = Sin(MilliSecs() / 5) * 100 + 155
    rEntityColor Cam, gam, gam, gam
  Else
    rEntityColor Cam, 255, 255, 255
  EndIf
  If KeyHit(4) Then
    For i = 1 To 7
      rFlipMesh Entity[i]
    Next
  EndIf
  If KeyHit(5) Then
    proj = 1 - proj
    rCameraProjMode Cam, proj + 1
    If proj Then rCameraZoom Cam, .251 Else rCameraZoom Cam, 1
  EndIf
  If KeyHit(6) Then
    wf = 1 - wf
    rWireFrame wf
  EndIf

  ;FPS
  loops = loops + 1
  If MilliSecs() - time1 > 500 Then
    FPS# = loops * 2
    loops = 0
    time1 = MilliSecs()
  End If

  rRenderWorld()
  UpdateDebugLine(10, 10)

  Color 0, 0, 0
  Rect 200, 10, 500, 105
  Color 255, 255, 255
  Rect 199, 9, 502, 107, False
  Text 205, 15, "Press key 1 to set random vertex-colors."
  Text 205, 35, "Press key 2 to swich gamma mode."
  Text 205, 55, "Press key 3 to flip all entitys."
  Text 205, 75, "Press key 4 to change camera project mode."
  Text 205, 95, "Press key 5 to change wireframe mode."
  Flip 0
Wend
End